Subject: Re: bug#20173: 24.4; Rendering misallocates combining marks on ligatures
From: Stefan Kangas <[email-masked]>
To: Eli Zaretskii <[email-masked]>
Cc: Richard Wordingham <[email-masked]>, [email-masked]
Date: Mon, 17 Aug 2020 22:45:26 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Eli Zaretskii <[email-masked]> writes:

>> Date: Fri, 27 Mar 2015 09:04:44 +0000
>> From: Richard Wordingham <[email-masked]>
>> Cc: [email-masked]
>>
>> On Tue, 24 Mar 2015 19:03:38 +0200
>> Eli Zaretskii <[email-masked]> wrote:
>>
>> > > Date: Tue, 24 Mar 2015 08:28:28 +0000
>> > > From: Richard Wordingham <[email-masked]>
>> > > Cc: [email-masked]
>>
>> > > You might want to first check whether composed Arabic is
>> > > usable. Doesn't making each word a grapheme cluster makes editing
>> > > unpleasant?
>>
>> > I don't know; I don't speak or write any of the languages that use the
>> > Arabic script.  I expect the users that do to come up and ask for
>> > features they miss.  We already allow deletion of single codepoints,
>> > even when they are composed; we might as well provide similar features
>> > for movement or whatever.
>>
>> I forgot that grapheme clustering is done in m17n, not Emacs itself.
>> The m17n code (in ARAB-OTF.flt) is reasonable - it clusters letters
>> with combining marks.  It *seems* I have a problem with tpu-forward-char
>> and tpu-backward-char; it's as though there's an initialisation fault
>> which stops them stepping through the Arabic compositions at first.  It
>> may be an issue with the presumably underlying forward-char and
>> backward-char; I haven't investigated further.  I'll have to record
>> the exact actions provoking the problem before I formally record a bug.
>
> Please try in "emacs -Q" without activating the TPU emulation.

More information was requested, but none was given within 5 years, so
I'm closing this bug.  If this is still an issue, please reply to this
email (use "Reply to all" in your email client) and we can reopen the
bug report.

Best regards,
Stefan Kangas